#ifndef TPINTERFACE_H
#define TPINTERFACE_H

#ifdef HAVE_CONFIG_H
#include  <config.h>
#endif

#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <tpengine.h>
#include <tpcommon.h>
#include <tpio_unix.h>
#include <tpclient.h>
#include "support.h"
#include <gtk/gtk.h>

#define MASTERSERVER "master.tst.dk"
#define MASTERSERVERPORT 1641
#define TESTSERVER 	"test.tst.dk"
#define TESTSERVERPORT	1640

enum {
    MYSTATE_IDLE,
    MYSTATE_GETSERVERLIST,
    MYSTATE_STDTEST,
    NOSUCHHOST,
    LOOKUPINITFAIL,
    QUERYMASTERFAIL,
    QUERYMASTERINITFAIL
};

TPEngine*	engp;
time_t		starttime, stoptime;
int		my_state;
gboolean	has_server;
int		substate;
/*gchar*		current_server;
USHORT		current_port;*/
gboolean	master_mode;
gboolean	detached_state;

const gchar* initialize(gboolean);
void clear_test_results(gboolean);
void update_testing(TPEngine*, gboolean);
void* tptest(void*);
void update_progressbar(TPEngine*);
void do_error(gchar*);
void update_best_rate(TPEngine*);
void update_load_results(TPEngine*);
void fill_progressbar(void);
void init_progressbar(gboolean);
int name_lookup(TPEngine*);
int get_server_list(TPEngine*);
void update_server_list(TPEngine*, gboolean);
void server_selected(gboolean);
void show_message(const gchar*, const gchar*, gboolean);

#endif /* TPINTERFACE_H */
